#!/bin/sh

service ipmi start
export LD_LIBRARY_PATH=.:$LD_LIBRARY_PATH
echo ""
MACflash () {
ipmitool lan set 01 macaddr $1
}
test ! -e lfbmc.cfg && echo "lfbmc.cfg doesn't exist, please confirm the target BMC file" && exit
TargetVersion=$(cat lfbmc.cfg | cut -d 'R' -f 2 | cut -d '.' -f 1)
test ! -e [Rr]$TargetVersion.dcs && echo -e "Please check if target file name in 'lfbmc.cfg' is correct
and follows 'Rxxx.dcs' or 'Rxxxx.dcs' format or not.\n" && exit
echo "Target flash file is R$TargetVersion.dcs"


MajorVersion1=$(ipmitool raw 0x06 0x01 | cut -d ' ' -f 4)
MinorVersion1=$(ipmitool raw 0x06 0x01 | cut -d ' ' -f 5)
GetDeviceID1=$(ipmitool raw 0x06 0x01)
MAC=$(ipmitool lan print 01 | grep "MAC Address" | cut -d ':' -f 2-7)
ReservationSh=$(ipmitool raw 0x30 0x01 | cut -d ' ' -f 2)
NICMode=$(ipmitool raw 0x30 0x02 0x$ReservationSh 0x02 0x01 0x00 0x00 0x00 0x01 | cut -d ' ' -f 6)
IPSource=$(ipmitool raw  0xc 0x2 0x1 0x4 0x0 0x0 | cut -d ' ' -f 3)
IP1=$(ipmitool raw  0xc 0x2 0x1 0x3 0x0 0x0 | cut -d ' ' -f 3)
IP2=$(ipmitool raw  0xc 0x2 0x1 0x3 0x0 0x0 | cut -d ' ' -f 4)
IP3=$(ipmitool raw  0xc 0x2 0x1 0x3 0x0 0x0 | cut -d ' ' -f 5)
IP4=$(ipmitool raw  0xc 0x2 0x1 0x3 0x0 0x0 | cut -d ' ' -f 6)
MASK1=$(ipmitool raw  0xc 0x2 0x1 0x6 0x0 0x0 | cut -d ' ' -f 3)
MASK2=$(ipmitool raw  0xc 0x2 0x1 0x6 0x0 0x0 | cut -d ' ' -f 4)
MASK3=$(ipmitool raw  0xc 0x2 0x1 0x6 0x0 0x0 | cut -d ' ' -f 5)
MASK4=$(ipmitool raw  0xc 0x2 0x1 0x6 0x0 0x0 | cut -d ' ' -f 6)
D4GWay1=$(ipmitool raw  0xc 0x2 0x1 0xc 0x0 0x0 | cut -d ' ' -f 3)
D4GWay2=$(ipmitool raw  0xc 0x2 0x1 0xc 0x0 0x0 | cut -d ' ' -f 4)
D4GWay3=$(ipmitool raw  0xc 0x2 0x1 0xc 0x0 0x0 | cut -d ' ' -f 5)
D4GWay4=$(ipmitool raw  0xc 0x2 0x1 0xc 0x0 0x0 | cut -d ' ' -f 6)
echo ""
echo "****************************************************"
echo "Check Get Device ID Response Data : $GetDeviceID1	"
echo "Check Update Version Successfully : $MajorVersion1.$MinorVersion1	"
echo "****************************************************"

####Update BMC Version 1.16 through KCSUtility####
if [ "$MajorVersion1" -gt "1" ]; then
	if [ "$MajorVersion1" -gt "4" ]; then
		if [ "$MinorVersion1" -gt "9" ]; then
			export LD_LIBRARY_PATH=.:$LD_LIBRARY_PATH
			echo ""
			filename=`ls |grep [Rr]$TargetVersion.dcs`
			./dcsfwul64 -x -e=0 -f -o=1 -i=./$filename
				sleep 20
			exit
		else
			export LD_LIBRARY_PATH=.:$LD_LIBRARY_PATH
			echo ""
			filename=`ls |grep [Rr]$TargetVersion.dcs`
			./dcsfwul64 -x -e=0 -f -o=1 -i=./$filename
				sleep 20
		fi
	else
		export LD_LIBRARY_PATH=.:$LD_LIBRARY_PATH
		echo ""
		filename=`ls |grep [Rr]$TargetVersion.dcs`
		./dcsfwul64 -x -e=0 -f -o=1 -i=./$filename
			sleep 20
		exit
	fi
else
	if [ "$MajorVersion1" -gt "0" ]; then
		if [ "$MinorVersion1" -gt "12" ]; then
			if [ "$MinorVersion1" -gt "51" ]; then
				export LD_LIBRARY_PATH=.:$LD_LIBRARY_PATH
				echo ""
				filename=`ls |grep [Rr]$TargetVersion.dcs`
				./dcsfwul64 -x -e=0 -f -o=1 -i=./$filename
					sleep 20
				exit
			else
				export LD_LIBRARY_PATH=.:$LD_LIBRARY_PATH
				echo ""
				filename=`ls |grep [Rr]$TargetVersion.dcs`
				./dcsfwul64 -x -e=0 -f -o=1 -i=./$filename
					sleep 20
			fi
		else
			echo "*******************************************************************"
			echo "*     WARNING!!! WARNING!!! WARNING!!! WARNING!!! WARNING!!!      *"
			echo "*   Current version could not upgrade to the latest version!!!    *"
			echo "*            Utility will upgrade to V1.13 first!!!               *"
			echo "*******************************************************************"
			filename2=`ls |grep [Rr]113.dcs`
			./dcsfwul64 -x -e=0 -f -o=1 -i=./$filename2
				sleep 20
			echo ""
			echo "******************************************************************"
			echo "*    Please restart FBMC.sh to upgrate to the latest version.    *"
			echo "******************************************************************"
			exit
		fi
	else
		echo "*******************************************************************"
		echo "*     WARNING!!! WARNING!!! WARNING!!! WARNING!!! WARNING!!!      *"
		echo "*   Current version could not upgrade to the latest version!!!    *"
		echo "*            Utility will upgrade to V1.13 first!!!               *"
		echo "*******************************************************************"
		filename2=`ls |grep [Rr]113.dcs`
		./dcsfwul64 -x -e=0 -f -o=1 -i=./$filename2
			sleep 20
		echo ""
		echo "******************************************************************"
		echo "*    Please restart FBMC.sh to upgrate to the latest version.    *"
		echo "******************************************************************"
		
		
		exit
	fi
	
fi
echo "Restore LAN configuration to Default"
ipmitool raw 0x30 0x04 0xe2
sleep 30

echo "Cold reset BMC"
ipmitool raw 0x06 0x02
sleep 70

echo "Change Lan port from Dedicated NIC to Shared NIC"
ReservationSh=$(ipmitool raw 0x30 0x01 | cut -d ' ' -f 2)
ipmitool raw 0x30 0x03 0x$ReservationSh 0x02 0x01 0x00 0x00 0x00 0x01 0x00
sleep 30

echo "Select Shared NIC 2"
ReservationSh=$(ipmitool raw 0x30 0x01 | cut -d ' ' -f 2)
ipmitool raw 0x30 0x03 0x$ReservationSh 0x02 0x02 0x00 0x00 0x00 0x01 0x02
sleep 20

echo "Enter manufacturing test mode"
ipmitool raw 0x06 0x05 0x64 0x52 0x45 0x4d 0x24 0x73 0x74 0x38
sleep 5

echo "Flash BMC MAC with Shared NIC 2..."
MACflash $MAC
sleep 10
		
if [ "$NICMode" -eq "01" ]; then
	echo "Change Lan port to Dedicated NIC"
	ReservationSh=$(ipmitool raw 0x30 0x01 | cut -d ' ' -f 2)
	ipmitool raw 0x30 0x03 0x$ReservationSh 0x02 0x01 0x00 0x00 0x00 0x01 0x01
	sleep 20
else
	echo "Restore Lan Port to Default: Shared NIC 1"
	ReservationSh=$(ipmitool raw 0x30 0x01 | cut -d ' ' -f 2)
	ipmitool raw 0x30 0x03 0x$ReservationSh 0x02 0x01 0x00 0x00 0x00 0x01 0x00
	sleep 20
	ReservationSh=$(ipmitool raw 0x30 0x01 | cut -d ' ' -f 2)
	ipmitool raw 0x30 0x03 0x$ReservationSh 0x02 0x02 0x00 0x00 0x00 0x01 0x01
	sleep 30
fi
if [ "$IPSource" -eq "01" ]; then
	sleep 10
	echo "Set IP Source to static IP"
	ipmitool raw 0x0c 0x01 0x01 0x04 0x$IPSource
	sleep 10
	echo "Set static IP address"
	ipmitool raw 0x0c 0x01 0x01 0x03 0x$IP1 0x$IP2 0x$IP3 0x$IP4
	sleep 10
	echo "Set subnet mask"
	ipmitool raw 0x0c 0x01 0x01 0x06 0x$MASK1 0x$MASK2 0x$MASK3 0x$MASK4
	sleep 10
	echo "Set Default Gateway Address"
	ipmitool raw 0x0c 0x01 0x01 0x0c 0x$D4GWay1 0x$D4GWay2 0x$D4GWay3 0x$D4GWay4
	sleep 10
	ipmitool raw 0x0c 0x01 0x01 0x04 0x$IPSource
fi
echo "...done"

exit

