@echo off

::--------------------------------------------------------
::-- Version Information
::--------------------------------------------------------
@set FILE_NAME=allv259.bin
@set CHECK_VER="02 59"
@set DISPLAY_VER=02.59

::--------------------------------------------------------
::-- Main
::--------------------------------------------------------
if "%1%"=="s" GOTO PRESERVE_CONF
if "%1%"=="" GOTO NO_PRESERVE_CONF

	
:PRESERVE_CONF
call:subPreserve_Conf
goto END

:NO_PRESERVE_CONF
call:subNoPreserve_Conf
goto END

::--------------------------------------------------------
::-- Preserve configuration
::--------------------------------------------------------
:subPreserve_Conf

echo preserve configuration
echo.

echo 0 > count
:start
echo.
ipmiutil cmd 00 20 18 01 > PreID.txt
if "%PROCESSOR_ARCHITECTURE%"=="AMD64" goto 64BIT

:32BIT
echo Windows x86 Environment
echo =============================================
echo Updating Bootloader...
echo =============================================
socflash.exe if=%FILE_NAME% skip=0 offset=0 count=0x30000
echo =============================================
sleep 5
echo Updating Kernel...
echo =============================================
socflash.exe if=%FILE_NAME% skip=0x100000 offset=0x100000 count=0x1f0000
echo =============================================
sleep 5
echo Updating Root file system...
echo =============================================
socflash.exe if=%FILE_NAME% skip=0x300000 offset=0x300000 count=0x1b00000
echo =============================================
echo Wait 180 seconds and check Device ID
echo Please do not press any key while counting down
echo =============================================
goto check

:64BIT
echo Windows x64 Environment
echo =============================================
echo Updating Bootloader...
echo =============================================
socflash_x64.exe if=%FILE_NAME% skip=0 offset=0 count=0x30000
echo =============================================
sleep 5
echo Updating Kernel...
echo =============================================
socflash_x64.exe if=%FILE_NAME% skip=0x100000 offset=0x100000 count=0x1f0000
echo =============================================
sleep 5
echo Updating Root file system...
echo =============================================
socflash_x64.exe if=%FILE_NAME% skip=0x300000 offset=0x300000 count=0x1b00000
echo =============================================
echo Wait 180 seconds and check Device ID
echo Please do not press any key while counting down
echo =============================================
goto check

:check
sleep 180
ipmiutil cmd 00 20 18 01 > ID.txt
find %CHECK_VER% ID.txt
if "%ERRORLEVEL%"=="0" goto done
echo Check Device ID fail, retry again!!
goto addcount

:addcount
find "5" count > NULL
if "%ERRORLEVEL%"=="0" goto fail
find "4" count > NULL
if "%ERRORLEVEL%"=="0" echo 5 > count
find "3" count > NULL
if "%ERRORLEVEL%"=="0" echo 4 > count
find "2" count > NULL
if "%ERRORLEVEL%"=="0" echo 3 > count
find "1" count > NULL
if "%ERRORLEVEL%"=="0" echo 2 > count
find "0" count > NULL
if "%ERRORLEVEL%"=="0" echo 1 > count
goto start


:fail
echo.
echo ===================================================
echo Update BMC to %DISPLAY_VER% and retry 5 times but still fail
echo Please try again.
echo ===================================================
if exist Null del Null
goto subEND

:done
debond.exe
echo ===============================
echo Update BMC to %DISPLAY_VER% successfully
echo ===============================
if exist Null del Null
goto subEND

:subEND
settime.exe
del count
del ID.txt
goto:eof

::--------------------------------------------------------
::-- w/o Preserve configuration
::--------------------------------------------------------
:subNoPreserve_Conf

echo No preserve configuration
echo.

echo 0 > count
:wostart
echo.
if "%PROCESSOR_ARCHITECTURE%"=="AMD64" goto wo64BIT

:wo32BIT
echo Windows x86 Environment
socflash.exe if=%FILE_NAME% skip=0 offset=0 count=0x30000
sleep 5
socflash.exe if=%FILE_NAME% skip=0x40000 offset=0x40000
goto wocheck

:wo64BIT
echo Windows x64 Environment
socflash_x64.exe if=%FILE_NAME% skip=0 offset=0 count=0x30000
sleep 5
socflash_x64.exe if=%FILE_NAME% skip=0x40000 offset=0x40000
goto wocheck

:wocheck
echo Wait 180 seconds and check Device ID
echo Please do not press any key while counting down.
sleep 180

ipmiutil cmd 00 20 18 01 > ID.txt
find %CHECK_VER% ID.txt
if "%ERRORLEVEL%"=="0" goto wodone
echo Check Device ID fail, retry again!!
goto woaddcount

:woaddcount
find "5" count > NULL
if "%ERRORLEVEL%"=="0" goto wofail
find "4" count > NULL
if "%ERRORLEVEL%"=="0" echo 5 > count
find "3" count > NULL
if "%ERRORLEVEL%"=="0" echo 4 > count
find "2" count > NULL
if "%ERRORLEVEL%"=="0" echo 3 > count
find "1" count > NULL
if "%ERRORLEVEL%"=="0" echo 2 > count
find "0" count > NULL
if "%ERRORLEVEL%"=="0" echo 1 > count
goto wostart

:wofail
echo.
echo ===================================================
echo Update BMC to %DISPLAY_VER% and retry 5 times but still fail
echo Please try again.
echo ===================================================
if exist Null del Null
goto wosubEND

:wodone
echo ===============================
echo Update BMC to %DISPLAY_VER% successfully
echo ===============================
if exist Null del Null
goto wosubEND

:wosubEND
settime.exe
del count
del ID.txt
goto:eof
::--------------------------------------------------------
::-- end of file
::--------------------------------------------------------
:END
@echo off